org.apache.xpath.axes

## Class UnionPathIterator

- java.lang.Object
- - org.apache.xpath.Expression
  - - org.apache.xpath.patterns.NodeTest
    - - org.apache.xpath.axes.PredicatedNodeTest
      - - org.apache.xpath.axes.LocPathIterator
        - - org.apache.xpath.axes.UnionPathIterator

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable, SourceLocator, DTMIterator, PathComponent, SubContextList, ExpressionNode, XPathVisitable

    public class UnionPathIterator
    extends LocPathIterator
    implements java.lang.Cloneable, DTMIterator, java.io.Serializable, PathComponent

This class extends NodeSetDTM, which implements DTMIterator, and fetches nodes one at a time in document order based on a XPath UnionExpr. As each node is iterated via nextNode(), the node is also stored in the NodeVector, so that previousNode() can easily be done.

See Also:
  Serialized Form
Usage:
  **For advanced use only**

### Field Summary

### Fields inherited from class org.apache.xpath.axes.LocPathIterator

`m_lastFetched`

### Fields inherited from class org.apache.xpath.patterns.NodeTest

`SCORE_NODETEST, SCORE_NONE, SCORE_NSWILD, SCORE_OTHER, SCORE_QNAME, SHOW_BYFUNCTION, SUPPORTS_PRE_STRIPPING, WILD`

### Fields inherited from interface org.apache.xml.dtm.DTMIterator

`FILTER_ACCEPT, FILTER_REJECT, FILTER_SKIP`

### Constructor Summary

Constructors
Constructor and Description
`UnionPathIterator()` Constructor to create an instance which you can add location paths to.
`UnionPathIterator(Compiler compiler, int opPos)` Create a UnionPathIterator object, including creation of location path iterators from the opcode list, and call back into the Compiler to create predicate expressions.

### Method Summary

Methods
`void` `addIterator(DTMIterator expr)` Add an iterator to the union list.
`void` `callVisitors(ExpressionOwner owner, XPathVisitor visitor)` This will traverse the heararchy, calling the visitor for each member.
`java.lang.Object` `clone()` Get a cloned LocPathIterator that holds the same position as this iterator.
`static LocPathIterator` `createUnionIterator(Compiler compiler, int opPos)` This will return an iterator capable of handling the union of paths given.
`boolean` `deepEquals(Expression expr)` Compare this object with another object and see if they are equal, include the sub heararchy.
`void` `detach()` Detaches the iterator from the set which it iterated over, releasing any computational resources and placing the iterator in the INVALID state.
`void` `fixupVariables(java.util.Vector vars, int globalsSize)` This function is used to fixup variables from QNames to stack frame indexes at stylesheet build time.
`int` `getAnalysisBits()` Get the analysis bits for this walker, as defined in the WalkerFactory.
`int` `getAxis()` Returns the axis being iterated, if it is known.
`int` `nextNode()` Returns the next node in the set and advances the position of the iterator in the set.
`void` `setRoot(int context, java.lang.Object environment)` Initialize the context values for this expression after it is cloned.

### Methods inherited from class org.apache.xpath.axes.LocPathIterator

`allowDetachToRelease, asIterator, asNode, bool, cloneWithReset, execute, executeCharsToContentHandler, getContext, getCurrentContextNode, getCurrentNode, getCurrentPos, getDTM, getDTMManager, getExpandEntityReferences, getFilter, getFoundLast, getIsTopLevel, getLastPos, getLength, getPrefixResolver, getRoot, getWhatToShow, getXPathContext, incrementCurrentPos, isDocOrdered, isFresh, isMutable, isNodesetExpr, item, previousNode, reset, runTo, setCurrentContextNode, setCurrentPos, setEnvironment, setIsTopLevel, setItem, setShouldCacheNodes, size`

### Methods inherited from class org.apache.xpath.axes.PredicatedNodeTest

`acceptNode, callPredicateVisitors, canTraverseOutsideSubtree, getLocPathIterator, getPredicate, getPredicateCount, getPredicateIndex, getProximityPosition, getProximityPosition, initProximityPosition, isReverseAxes, resetProximityPositions, setLocPathIterator, setPredicateCount`

### Methods inherited from class org.apache.xpath.patterns.NodeTest

`debugWhatToShow, execute, execute, getDefaultScore, getLocalName, getNamespace, getNodeTypeTest, getStaticScore, initNodeTest, initNodeTest, setLocalName, setNamespace, setStaticScore, setWhatToShow`

### Methods inherited from class org.apache.xpath.Expression

`asIteratorRaw, assertion, error, execute, exprAddChild, exprGetChild, exprGetNumChildren, exprGetParent, exprSetParent, getColumnNumber, getExpressionOwner, getLineNumber, getPublicId, getSystemId, isStableNumber, num, warn, xstr`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.apache.xml.dtm.DTMIterator

`allowDetachToRelease, cloneWithReset, getCurrentNode, getCurrentPos, getDTM, getDTMManager, getExpandEntityReferences, getLength, getRoot, getWhatToShow, isDocOrdered, isFresh, isMutable, item, previousNode, reset, runTo, setCurrentPos, setItem, setShouldCacheNodes`

### Constructor Detail

#### UnionPathIterator

    public UnionPathIterator()

Constructor to create an instance which you can add location paths to.

#### UnionPathIterator

    public UnionPathIterator(Compiler compiler,
                     int opPos)
                      throws TransformerException

Create a UnionPathIterator object, including creation of location path iterators from the opcode list, and call back into the Compiler to create predicate expressions.

Parameters:
  `compiler` - The Compiler which is creating this expression.
  `opPos` - The position of this iterator in the opcode list from the compiler.
Throws:
  `TransformerException`

### Method Detail

#### setRoot

    public void setRoot(int context,
               java.lang.Object environment)

Initialize the context values for this expression after it is cloned.

Specified by:
  `setRoot` in interface `DTMIterator`
Overrides:
  `setRoot` in class `LocPathIterator`
Parameters:
  `context` - The XPath runtime context for this transformation.
  `environment` - The environment object. The environment in which this iterator operates, which should provide:
  - a node (the context node... same value as "root" defined below)
  - a pair of non-zero positive integers (the context position and the context size)
  - a set of variable bindings
  - a function library
  - the set of namespace declarations in scope for the expression.

  At this time the exact implementation of this environment is application dependent. Probably a proper interface will be created fairly soon.

#### addIterator

    public void addIterator(DTMIterator expr)

Add an iterator to the union list.

Parameters:
  `expr` - non-null reference to a location path iterator.

#### detach

    public void detach()

Detaches the iterator from the set which it iterated over, releasing any computational resources and placing the iterator in the INVALID state. After`detach` has been invoked, calls to `nextNode` or`previousNode` will raise the exception INVALID_STATE_ERR.

Specified by:
  `detach` in interface `DTMIterator`
Overrides:
  `detach` in class `LocPathIterator`

#### createUnionIterator

    public static LocPathIterator createUnionIterator(Compiler compiler,
                                      int opPos)
                                               throws TransformerException

This will return an iterator capable of handling the union of paths given.

Parameters:
  `compiler` - The Compiler which is creating this expression.
  `opPos` - The position of this iterator in the opcode list from the compiler.
Returns:
  Object that is derived from LocPathIterator.
Throws:
  `TransformerException`

#### getAnalysisBits

    public int getAnalysisBits()

Get the analysis bits for this walker, as defined in the WalkerFactory.

Specified by:
  `getAnalysisBits` in interface `PathComponent`
Overrides:
  `getAnalysisBits` in class `LocPathIterator`
Returns:
  One of WalkerFactory#BIT_DESCENDANT, etc.

#### clone

    public java.lang.Object clone()
                           throws java.lang.CloneNotSupportedException

Get a cloned LocPathIterator that holds the same position as this iterator.

Specified by:
  `clone` in interface `DTMIterator`
Overrides:
  `clone` in class `PredicatedNodeTest`
Returns:
  A clone of this iterator that holds the same node position.
Throws:
  `java.lang.CloneNotSupportedException`

#### nextNode

    public int nextNode()

Returns the next node in the set and advances the position of the iterator in the set. After a DTMIterator is created, the first call to nextNode() returns the first node in the set.

Specified by:
  `nextNode` in interface `DTMIterator`
Specified by:
  `nextNode` in class `LocPathIterator`
Returns:
  The next `Node` in the set being iterated over, or `null` if there are no more members in that set.

#### fixupVariables

    public void fixupVariables(java.util.Vector vars,
                      int globalsSize)

This function is used to fixup variables from QNames to stack frame indexes at stylesheet build time.

Overrides:
  `fixupVariables` in class `PredicatedNodeTest`
Parameters:
  `vars` - List of QNames that correspond to variables. This list should be searched backwards for the first qualified name that corresponds to the variable reference qname. The position of the QName in the vector from the start of the vector will be its position in the stack frame (but variables above the globalsTop value will need to be offset to the current stack frame).

#### getAxis

    public int getAxis()

Returns the axis being iterated, if it is known.

Specified by:
  `getAxis` in interface `DTMIterator`
Overrides:
  `getAxis` in class `LocPathIterator`
Returns:
  Axis.CHILD, etc., or -1 if the axis is not known or is of multiple types.

#### callVisitors

    public void callVisitors(ExpressionOwner owner,
                    XPathVisitor visitor)

Description copied from interface: `XPathVisitable`
This will traverse the heararchy, calling the visitor for each member. If the called visitor method returns false, the subtree should not be called.

Specified by:
  `callVisitors` in interface `XPathVisitable`
Overrides:
  `callVisitors` in class `LocPathIterator`
Parameters:
  `owner` - The owner of the visitor, where that path may be rewritten if needed.
  `visitor` - The visitor whose appropriate method will be called.
See Also:
  `XPathVisitable.callVisitors(ExpressionOwner, XPathVisitor)`

#### deepEquals

    public boolean deepEquals(Expression expr)

Description copied from class: `Expression`
Compare this object with another object and see if they are equal, include the sub heararchy.

Overrides:
  `deepEquals` in class `PredicatedNodeTest`
Parameters:
  `expr` - Another expression object.
Returns:
  true if this objects class and the expr object's class are the same, and the data contained within both objects are considered equal.
See Also:
  `Expression.deepEquals(Expression)`